#include "headers.h"

#ifdef JSHERIFF

UINT32 iRomSize_JFIF( UINT8 *pImage, UINT32 *iBufSize, UINT16 *iHeight, UINT16 *iWidth) {

	UINT8 *p;
	UINT32 max = *iBufSize;
	UINT32 index;

	for( index =0; index < max; index++)
		if( pImage[index] == 0xFF && pImage[index+1] == 0xC0 ) {	// search for 0xFFC0
			p = &pImage[index];
			*iHeight = ( p[5] << 8 ) | p[6];
			*iWidth = ( p[7] << 8 ) | p[8];
			*iBufSize = 0;				// skip no bytes
			return( max );				// success
		}
	return 0;							// fail
}
 
#else	// JSHERIFF

UINT32 iRomSize_JFIF( UINT8 *pImage, UINT32 *iBufSize, UINT16 *iHeight, UINT16 *iWidth) {

	bool dim = false;
	bool begin = false;

	UINT8 *p;
	UINT32 iSize = 0;
	UINT32 max = *iBufSize;
	UINT32 index;

	for( index =0; index < max; index++)
		if( pImage[index] == 0xFF ) {	// search for 0xFFC0
			p = &pImage[index];
			switch (p[1]) {
			case 0xC0:					// dimensions
				*iHeight = ( p[5] << 8 ) | p[6];
				*iWidth = ( p[7] << 8 ) | p[8];
				dim = true;
				break;
			case 0xDA:					// number of bytes to skip
				index += ( p[2] << 8 ) | p[3];
				index += 2;
				*iBufSize  = index;
				begin = true;
				break;
			case 0xD9:					// total length
				if( begin )
					iSize = (UINT32) (index - *iBufSize);
			}
			if( dim && iSize )
				return( iSize );		// success
		}
	return 0;							// fail
}
 
#endif	// JSHERIFF
