#include <stdio.h>
#include <string.h>
#include <vector>

#include "../id.h"			// for external szExt declaration

std::vector<tagInfo> vInfo;
extern char *szExt = 0;		// definition here should satisfy compiler
extern char *szSortDir = 0;	// definition here should satisfy compiler

int unLF( char *p ) {
	// remove lf from string (fgets does not remove)
	// TODO: does this work for all OS?
	// break on the first non-HT, LF, FF, CR
	int i;

	i = strlen( p );
	while( --i ) {
		if( p[i] > 8 && p[i] < 14 )
			p[i] = '\0';
		else
			break;
	}
	return 1;
	// TODO: return strlen?  what would be useful? return char *?
}

char *AddExts ( char *p ) {	// space-separated null-term
	size_t x = 0;

	unLF( p );
#ifndef JSORT
	// hack to have extensions at the top of the dat file - redirectable
	fprintf(stdout, "%s \n", p);
#endif

	while(p[x]) {
		if(p[x] == ' ')
			p[x] = '\0';
		x++;
		if(p[x] > 8 && p[x] < 14)	// HT, LF, VT, FF, CR
			break;
	}

	szExt = new char[x+2];	// need double null term
	if( szExt ) {
		memcpy(szExt, p, x);
		szExt[x++] = '\0';
		szExt[x] = '\0';
	}
	return szExt;	
}

unsigned MatchExt(char *cTmpext, char *ext) {
	int j=0;
	int c,d;
	while(( c=tolower( ext[j] ) ) && ( d=tolower( cTmpext[j] ) )) {
		if(c != d) {
			j = 0;
			break;
		}
		j++;
	}
	return j;	// True if matched else false
}

int MatchExtToArray(char *sztmpExt) {
	int x = 0;
	int iRet = 0;

	while(szExt[x]) {
		if(szExt[x] == '*')
			x++;
		if(MatchExt( &szExt[x], sztmpExt)) {
			iRet = 1;
			break;
		}
		while(szExt[x++]);
	}
	
	return iRet;
}

void UnloadDat( void ) {
	vInfo.clear();			// call erase() for each element
}

int LoadDat( char *pszSystem ) {
	FILE *fp;
	tagInfo ri;					// temp struct

	char szTemp[MAX_BUFF];			// to hold CRC and name data
#ifdef JSORT
	char szTokSep[] = " \n\r";
#endif
	char *p;
	int iRet = 0;					// 0 == fail, number loaded

	szSortDir = new char[strlen( pszSystem ) + 1];
	strcpy( &szSortDir[0], pszSystem );

	strcpy( &szTemp[0], pszSystem );
#ifdef JSORT
	strcat( &szTemp[0], ".crc" );
#else
	strcat( &szTemp[0], ".dat" );
#endif
	if( fp = fopen(&szTemp[0], "r")) {

		vInfo.reserve(MAX_RESERVE);

		if(fgets( &szTemp[0], MAX_BUFF, fp)) {

			if(!szExt)				// else use command-line
#ifdef JSORT
				AddExts("*.jpg");			// this must exist
#else
				AddExts( &szTemp[0] );
#endif

			// skip info and column info
			while(fgets( &szTemp[0], MAX_BUFF, fp)) {
				if(szTemp[0] == '-')
					break;
			}

			// JSheriff example:
			// dhe2003.jpg      91,889   800 x  600  7F24D3F2  

			while(fgets( &szTemp[0], MAX_BUFF, fp)) {
				if( szTemp[0] == '-')
					break;
				if(p = strtok( &szTemp[0], &szTokSep[0] )) {
					// TODO: ri.bHave should be set in LoadHave() instead
					ri.bHave = 0;
					strncpy( &ri.szName[0], p, FNLEN );
					p = strtok( NULL, &szTokSep[0] );
					// remove commas,
					ri.size = strtoul( p, NULL, 10 );	// 10 = decimal (base 10)
					p = strtok( NULL, &szTokSep[0] );
					ri.width = strtoul( p, NULL, 10 );	// 10 = decimal (base 10)
					p = strtok( NULL, &szTokSep[0] );
					// this should be "x", ignore
					p = strtok( NULL, &szTokSep[0] );
					ri.height = strtoul( p, NULL, 10 );	// 10 = decimal (base 10)
					p = strtok( NULL, &szTokSep[0] );
					ri.crc = strtoul( p, NULL, 0x10 );	// 0x10 = hex (base 16)
#ifdef _DEBUG
					if(!ri.crc)
						fprintf(stderr, "CRC is null: %s\n", &szTemp[0]);
#endif	// _DEBUG
							
					vInfo.push_back( ri);
					iRet++;
				}			// else failure
			}
		} else				// initial fgets() failure
			szExt = 0;

		fclose(fp);
	}
	return iRet;
}

tagInfo *IdProc( unsigned int iCRC) {
	tagInfo *p = 0;
	std::vector<tagInfo>::iterator itInfo = vInfo.begin();
	while( itInfo < vInfo.end() ) {
		if(itInfo->crc == iCRC) {
			p = itInfo;
			break;
		}
		itInfo++;
	}
	return p;
}
