#include <ctype.h>					// toupper()
#include <stdio.h>
#include <string.h>

#include "../opts.h"
#include "headers.h"				// gamefile and other format headers for size calculation
#include "../id.h"
#include "../dir_ops.h"

#include "../crc32.h"

#ifndef _MAX_PATH
#define _MAX_PATH 255
#endif	// _MAX_PATH

#ifdef _DEBUG
#include <conio.h>					// getche()
#endif

int sort_proc (char *szFile, char *szPath, int iOpts) {
	// structure vars
	FILE *fpFile = 0;
//	tagInfo ti;
	tagJpgInfo ti;

	// data vars
	int iRet = 1;			// TRUE
	unsigned int iTmp;
	char *p;

	char szFileName[_MAX_PATH];
	ti.crc = 0;				// fail if not set

	if(szPath) {
		strcpy( &szFileName[0], szPath);
		strcat( &szFileName[0], szFile);
	} else
		strcpy( &szFileName[0], szFile);

	unsigned int iBytes;
	unsigned char *pImage;

	fpFile = fopen(&szFileName[0], "rb");
	if(fpFile) {
		fseek(fpFile, 0, SEEK_END);
		iBytes = ftell(fpFile);
		fseek(fpFile, 0, SEEK_SET);
		pImage = new unsigned char[iBytes];
		ti.size = iBytes;
		fread(pImage, iBytes, sizeof(char), fpFile);
/*
#ifdef _DEBUG
		if(osd_checkmem(p, iBytes)) {		// send to redirected file
			fprintf(stdout, "\nErr: Bad memory ptr before MemGetCRC 0x%h size %u, ignoring file\n---> %s\n", p, file_size, szFile);
			break;
		} else
#endif
*/
		// iBytes holds number of allocated bytes == file size
		iTmp = iRomSize_JFIF(pImage, &iBytes, &ti.height, &ti.width);
		// iBytes is now #bytes to skip, iTmp == #bytes to examine
		ti.crc = MemGetCRC(pImage, iTmp, iBytes, 0);

		delete [] pImage;
		fclose(fpFile);
	} else
		fprintf(stderr, "\nErr: Unable to open file %s\n", &szFileName[0]);

	if( ti.crc && (iOpts & OPT_DUMP) ) {

//dhe2003.jpg   1,991,889   800 x  600  7F24D3F2  
		fprintf( stdout,"%-12s  %9u  %4u x %4u  %0x\n",
			szFile, ti.size, ti.width, ti.height, ti.crc );

	} else if( ti.crc && (iOpts & OPT_RENAME) ) {

		tagInfo *gi = IdProc( ti.crc );

		if(gi) {
			// have to verify dimensions
			p = &(gi->szName[0]);				// new name
			if(gi->bHave) {
				Move_File( &szFileName[0], "dupes", p, 1);	// keep renaming
				// gi->bHave++;
			} else {
				gi->bHave++;
#ifdef _DEBUG
				fprintf( stdout,"\nRename %s to %s? ", szFile, p);
				int q = getche();
//				int q = 'y';
				if(q == 'y' || q == 'Y') {
//#else
//					fprintf( stdout,"\n%s -> %s\n", szFile, p);
#endif
					if(Move_File( &szFileName[0], szSortDir ? szSortDir : "ren", p )) {		// file exists or bad name
						Move_File( &szFileName[0], "dupes", p, 1 );
					}
#ifdef _DEBUG
				} else if(q == 0x1b || q == 'q' || q == 'Q')
					iRet = 0;
#endif
			}
		}
	}	// else no crc found
	return iRet;
}
