#include <ctype.h>					// toupper()
#include <stdio.h>
#include <string.h>

#include "headers.h"				// gamefile and other format headers for size calculation
#include "../opts.h"
#include "../id.h"
#include "../dir_ops.h"

#include "../crc32.h"
#include "zlib.h"				// for zip/unzip support
#include "unzip.h"				// unzip routines (MAME team)

#ifndef _MAX_PATH
#define _MAX_PATH 255
#endif	// _MAX_PATH

#ifdef _DEBUG
#include <conio.h>					// getche()
#endif

int sort_proc (char *szFile, char *szPath, int iOpts) {
	// structure vars
	FILE *fpFile = 0;
	ZIP *zip = 0;
	zipent *ent;

	// data vars
	int UnZipped = 0;
	int iRet = 1;			// TRUE
	int iErr = 0;
	int iType = 0;						// must be signed
	char *p;
	unsigned int iCRC = 0;
//	unsigned iFiles = 0;

	char szFileName[_MAX_PATH];

	p = strrchr(szFile, '.');			// must have extension
	if( !p )
		return 0;

	if(szPath) {
		strcpy( &szFileName[0], szPath);
		strcat( &szFileName[0], szFile);
	} else
		strcpy( &szFileName[0], szFile);

	if(MatchExt(p, ".zip"))
		zip = openzip( &szFileName[0] );
	else {
		UnZipped = 1;
	}

//	if(zip->total_entries_cent_dir > 1) {
//		closezip(zip);
//		zip = 0;
//	}

	while( UnZipped || (zip && readzip( zip ))) {	// cycle through files - test for valid pointer first

		if(zip) {
			ent = &(zip->ent);						// need ent for reading
			p = strrchr(ent->name, '.');
		}											// p still points to extension if not .zip

		if(p) {
			if(MatchExtToArray(p))					// is it valid for this CRC?
				iType = iRomType(p);				// index for iRom_Size_ ()
			else
				iType = 0;
		} else {
			iType = -1;
			// TODO: run auto-id procedure for unknown games
		}

		if(iType == 1 && zip ) {	// no header, use zip crc

			iCRC = ent->crc32;

		} else if(iType > 0) {

			unsigned int iBytes;
			unsigned char *pImage;

			// Get file length, allocate, and read
			if(zip) {
				iBytes = ent->uncompressed_size;
				pImage = new unsigned char[iBytes];
				readuncompresszip( zip, ent, (char *) pImage );
			} else {
				fpFile = fopen(&szFileName[0], "rb");
				if( !fpFile )
					return 0;
				fseek(fpFile, 0, SEEK_END);
				iBytes = ftell(fpFile);
				fseek(fpFile, 0, SEEK_SET);
				pImage = new unsigned char[iBytes];
				fread(pImage, iBytes, sizeof(char), fpFile);
			}
/*
#ifdef _DEBUG
			if(osd_checkmem(p, iBytes)) {		// send to redirected file
				fprintf(stdout, "\nErr: Bad memory ptr before MemGetCRC 0x%h size %u, ignoring file\n---> %s\n", p, file_size, szFile);
				break;
			} else
#endif
*/
			// iBytes holds number of allocated bytes == file size
			iCRC = GetRomSize[iType](pImage, &iBytes);
			// iBytes is now #bytes to skip, iCRC == #bytes to examine
			iCRC = MemGetCRC(pImage, iCRC, iBytes, 0);

			delete [] pImage;
//			if(!zip) break;			// not a zip file, end loop - spaghetti
//			UnZipped = 0;			// alternate way of breaking
		}
		UnZipped = 0;
	}
	
	if(zip)
		closezip(zip);
	else {
		if(fpFile)
			fclose(fpFile);
		else
			if(iType)
				fprintf(stderr, "\nErr: Unable to open file %s\n", &szFileName[0]);
	}

	if( iCRC && (iOpts & OPT_DUMP) ) {

		fprintf( stdout,"%08x %s\n", iCRC, szFile );

	} else if( iCRC && (iOpts & OPT_RENAME) ) {

		tagInfo *gi = IdProc( iCRC );

		if(gi) {
			p = &(gi->szName[0]);				// new name
			if(gi->bHave) {
				Move_File( &szFileName[0], "dupes", p, 1);	// keep renaming
				// gi->bHave++;
			} else {
				gi->bHave++;
#ifdef _DEBUG
				fprintf( stdout,"\nRename %s to %s? ", szFile, p);
				int q = getche();
//				int q = 'y';
				if(q == 'y' || q == 'Y') {
//#else
//					fprintf( stdout,"\n%s -> %s\n", szFile, p);
#endif
					if(Move_File( &szFileName[0], szSortDir ? szSortDir : "ren", p )) {		// file exists or bad name
						Move_File( &szFileName[0], "dupes", p, 1 );
					}
#ifdef _DEBUG
				} else if(q == 0x1b || q == 'q' || q == 'Q')
					iRet = 0;
#endif
			}
		}
	}	// else no crc found
	return iRet;
}
