#define STRICT
#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/stat.h>
//#include <sys/dir.h>
#include <dirent.h>
#include <ctype.h>	// for tolower
#include <stdio.h>
#include <string.h>

#ifndef _MAX_PATH
#define _MAX_PATH 255
#endif

#ifndef NULL
#define NULL 0
#endif

int strccmp( const char *sz1, const char *sz2) {
	char c1, c2;
	int count = 0;

	while( (c1 = tolower( sz1[count] )) && (c2 = tolower( sz2[count] ))) {	// run until end of string

		if( c1 > c2 )
			return 1;
		else if( c1 < c2 )
			return -1;

		count++;
	}
	return 0;
}
			

int walkdir( char *szWalkdir, int (*PFN) (char *filename, char *dir, int iopts), char *szExt, int iOpts ) {

	int iRet = 0;
	int iCount = 0;

	dirent *dp;
	DIR *dfd;

//	if( szExt[0] == '*')								// use extension only
//		szExt++;

	
	if((dfd = opendir(szWalkdir)) != NULL) {
		while((dp = readdir(dfd)) != NULL) {
			if(dp->d_name[0] != '.') {
				struct stat stbuf;
				if(stat(dp->d_name, &stbuf) == -1) {
					printf("walkdir: stat() failed on %s\n", dp->d_name);
					continue;
				}

//				if((stbuf.st_mode & S_IFDIR) == S_IFDIR) {
//					strcat( cFile, "/" );
//					walkdir( cFile, PFN, szExt );
//				} else {								// not a dir

				if((stbuf.st_mode & S_IFDIR) == S_IFDIR) {
					if(!strccmp( strrchr( dp->d_name, '.'), szExt )) {
						iRet = PFN( dp->d_name, szWalkdir, iOpts );
						if(iRet)
							iCount++;
					}
				}
			}
//			if(kbhit())	{					// ASCII ESCAPE
//				printf("\nUser cancelled\n");
//				break;
//			}
		}
		closedir(dfd);
	} else {
		printf("walkdir: can't open %s\n", szWalkdir);
		return 0;
	}

	dfd = 0;
	return iCount;	//	---------if succeeded, return TRUE
}
