#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

#ifndef _MAX_PATH
#define _MAX_PATH 255
#endif

int osd_checkmem(char *p, unsigned len) {
	return IsBadReadPtr(p, len);
}

int CheckDir( char *szDir, char *szSubDir ) {
	WIN32_FIND_DATA fdFileInfo;
	int iRet = 1;
	char Temp[_MAX_PATH];

	strcpy((char *) Temp, szDir);
	strcat( Temp, szSubDir );

	if( FindFirstFile( Temp, &fdFileInfo ) == INVALID_HANDLE_VALUE) {
		LPSECURITY_ATTRIBUTES lpSA = new SECURITY_ATTRIBUTES;
		lpSA->nLength = sizeof(SECURITY_ATTRIBUTES);
		lpSA->lpSecurityDescriptor = NULL;
		lpSA->bInheritHandle = FALSE;
		iRet = CreateDirectory( Temp, lpSA );
		delete lpSA;
	}
	return( iRet );
}

int Move_File( char *szFile, char *szSubDir, char *szNew, int inc_ext) {	// increment extension on fail
	
	char *szDest = new char[256];				// no internal storage, small stack
	int iRet;

	char *p = strrchr( szFile, '\\' );
	if(p) {
		strcpy( szDest, szFile );
		p = strrchr( szDest, '\\' );
		p++;									// point after last slash
	} else {
		strcpy(szDest, ".\\");					// default dir
		strcat(szDest, szFile);
		p = &szDest[2];
	}

	if(szSubDir) {								// insert subdir

		char c = *p;
		*p = 0;
		if(CheckDir(szDest, szSubDir)) {
			iRet = 0;
			*p = c;
			if(szNew) {
				strcpy( p, szSubDir );
				strcat( p, "\\" );
				strcat( p, szNew );
			} else {
				int len=strlen(p);
				char *pTmp = new char[len+1];	// copy from end backward can eliminate this
				strcpy( pTmp, p );
				strcpy( p, szSubDir );			// null-term
				strcat( p, "\\" );
				strcat( p, pTmp );
				delete [] pTmp;
			}
		}
	} else {
		if(szNew)
			strcpy(p, szNew);
	}

	p = strrchr(szFile, '.');
	char *t = strrchr(szDest, '.');
	if(!t || strcmp(p, t)) {
		if(p) {
			strcat(szDest, p);
		}
	}
	iRet = rename(szFile, szDest);
	if(iRet && inc_ext) { // keep renaming until we find a winner
		t = szDest;
		while(*t)
			t++;
		t--;
		for(*t='0'; *t<='9'; (*t)++) {
			if(!rename(szFile, szDest))
				break;
		}
	}
	delete [] szDest;
	return iRet;
}

FILE *TempFile( signed int start ) {	// should work throughout life of program
	static int index;
	static FILE *fpt = 0;
	char cName[15];

	if(start >= 0)						// initialize starting number
		index = start;					// else index is static

	if(index>10000 || index<0)
		index = 1;

	sprintf(cName, "tmp%04u.fds", index++);

	while(fpt = fopen(cName, "rb")) {	// fails if file exists
		fclose(fpt);
		sprintf(cName, "tmp%04u.fds", index++);
		if(index>9999) {
			return(0);
		}
	} 

	if(!fpt) {
		fpt = fopen(cName, "wb");
	}
	return (fpt);
}


