// #include "types.h"				// crc.h includes types.h

#include "crc32.h"

UINT32 crcTable[256];		// calculated CRC table to prevent corruption/mistakes

/* MemGetCRC*****************************************************************/
UINT32 MemGetCRC( UINT8 *cImage, UINT32 size, UINT32 skip_bytes, UINT32 crcStart )
{
	register UINT32 crc;
	UINT32		x;

	if(crcStart)				// for CRC in parts i.e. read part of a file, then another.
		crc = crcStart;
	else
		crc = 0xFFFFFFFF;		// start over

	size += skip_bytes;

	for(x=skip_bytes; x<size ; x++) {
		//need to test for valid memory pointer?
		crc = ((crc>>8) & 0x00FFFFFF) ^ crcTable[ (crc^cImage[x]) & 0xFF ];
	}
	//if( size ) return 0;								/* premature EOF */
	return( crc^0xFFFFFFFF );
}

/* crcgen ********************************************************************/
void crcgen( void )
{
	UINT32 crc, poly;
	INT32     i, j;

	poly = 0xEDB88320L;
	for (i=0; i<256; i++) {
		crc = i;
		for (j=8; j>0; j--) {
			if (crc&1) {
				crc = (crc >> 1) ^ poly;
			} else {
				crc >>= 1;
			}
		}
		crcTable[i] = crc;
	}
}
/*****************************************************************************/
